type token =
  | LIDENT of (string)
  | UIDENT of (string)
  | INTEGER of (string)
  | OP1 of (string)
  | OP2 of (string)
  | OP3 of (string)
  | OP4 of (string)
  | OPPREF of (string)
  | FLOAT of (Ptree.real_constant)
  | STRING of (string)
  | AND
  | AS
  | AXIOM
  | CLONE
  | ELSE
  | END
  | EPSILON
  | EXISTS
  | EXPORT
  | FALSE
  | FORALL
  | GOAL
  | IF
  | IMPORT
  | IN
  | INDUCTIVE
  | LEMMA
  | LET
  | LOGIC
  | MATCH
  | META
  | NAMESPACE
  | NOT
  | PROP
  | OR
  | THEN
  | THEORY
  | TRUE
  | TYPE
  | USE
  | WITH
  | ABSTRACT
  | ABSURD
  | ANY
  | ASSERT
  | ASSUME
  | BEGIN
  | CHECK
  | DO
  | DONE
  | DOWNTO
  | EXCEPTION
  | FOR
  | FUN
  | INVARIANT
  | LABEL
  | MODEL
  | MODULE
  | MUTABLE
  | PARAMETER
  | RAISE
  | RAISES
  | READS
  | REC
  | TO
  | TRY
  | VARIANT
  | WHILE
  | WRITES
  | ARROW
  | BACKQUOTE
  | BAR
  | COLON
  | COMMA
  | DOT
  | EQUAL
  | FUNC
  | LAMBDA
  | LTGT
  | LEFTPAR
  | LEFTPAR_STAR_RIGHTPAR
  | LEFTSQ
  | LRARROW
  | PRED
  | QUOTE
  | RIGHTPAR
  | RIGHTSQ
  | UNDERSCORE
  | EOF
  | AMPAMP
  | BARBAR
  | LEFTBRC
  | RIGHTBRC
  | SEMICOLON

val lexpr_eof :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Ptree.lexpr
val list0_decl_eof :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Theory.theory_uc
val logic_file_eof :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Theory.theory Theory.Mnm.t
val program_file :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Ptree.program_file
